#include <iostream>
using namespace std;

class Elevador {           // Define uma classe denominada Elevador. 
private:                   // Controle de acesso (público)
    // Atributos de Elevador
    int andar_atual;       // Declarando os atributos
    int total_andares;
    int capacidade; 
    int qtd_pessoas;     
public: 
    // Métodos
    // Construtor default
    Elevador() :
            capacidade( 20 ),
            total_andares( 20 ),
            qtd_pessoas( 0 ),
            andar_atual( 0 ) {}    

    Elevador( int capacidade, int total_andares ) : 
            capacidade( capacidade ),
            total_andares( total_andares ),
            qtd_pessoas( 0 ),
            andar_atual( 0 ) {}      
    
    void entra() {
        // qtd_pessoas = qtd_pessoas + 1;
        if( qtd_pessoas < capacidade )
            qtd_pessoas++;        
        else
            cout << "Elevador está cheio" << endl;
    } 
    
    void sai() {
        if( qtd_pessoas > 0 )
            qtd_pessoas--;
        else
            cout << "Elevador está vazio" << endl;
    }  
    void sobe() {
        if( andar_atual < total_andares )
            andar_atual++;
        else
            cout << "Elevador está no último andar" << endl;            
    } 
    void desce() {
        if( andar_atual > 0 )
            andar_atual--;
        else
            cout << "Elevador já está no térreo" << endl;
    }
    // Imprime o estado do objeto
    void imprime() {
        cout << "Andar atual:      " << andar_atual << endl;
        cout << "Qtd. de pessoas:  " << qtd_pessoas << endl;
        cout << "Capacidade:       " << capacidade << endl;
        cout << "Total de andares: " << total_andares << endl << endl;        
    }
    int getAndarAtual() {
        return andar_atual;
    }
    int getCapacidade() {
        return capacidade;
    }
    int getTotalAndares() {
        return total_andares;
    }
    int getQtdPessoas() {
        return qtd_pessoas;
    } 
};

int main() {
    Elevador elevador(10, 15); // Chamando o construtor parametrizado
    Elevador E1; // chamando um construtor default    

    for( int i = 0; i < 5; i++ ) {
        elevador.imprime();    
        elevador.entra();
    }

    for( int i = 0; i < 5; i++ )
        elevador.sobe();

    int andar_atual = elevador.getAndarAtual(); 
}

#if 0
int main() {
    Elevador E1;         // Instanciando o objeto E1
    Elevador E2;         // Instanciando o objeto E2
    
    // chamando o método inicializa_elevador
    // Capacidade = 10
    // Total de Andares = 16 
    E1.inicializa_elevador( 10, 16 );  
    cout << "Capacidade E1: " << E1.capacidade << endl;
    
    int cap;
    int total;
    cout << "Entre com a capacidade de E2: ";
    cin >> cap;    
    cout << "Entre com o total de andares de E2: ";
    cin >> total;
    // Inicializando o objeto E2 com as variáveis lidas do teclado
    E2.inicializa_elevador( cap, total );
    cout << "Capacidade E2: " << E2.capacidade << endl;

}

#endif
